##// END OF EJS Templates
fix: iptables needs iptables-persistent package...
Unknown -
r297:3fa6680c3af6
parent child
Show More
@@ -1,763 +1,763
1 #!/bin/sh
1 #!/bin/sh
2
2
3 ########################################################################
3 ########################################################################
4 # rpi23-gen-image.sh 2015-2017
4 # rpi23-gen-image.sh 2015-2017
5 #
5 #
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 #
7 #
8 # This program is free software; you can redistribute it and/or
8 # This program is free software; you can redistribute it and/or
9 # modify it under the terms of the GNU General Public License
9 # modify it under the terms of the GNU General Public License
10 # as published by the Free Software Foundation; either version 2
10 # as published by the Free Software Foundation; either version 2
11 # of the License, or (at your option) any later version.
11 # of the License, or (at your option) any later version.
12 #
12 #
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 #
14 #
15 # Big thanks for patches and enhancements by 20+ github contributors!
15 # Big thanks for patches and enhancements by 20+ github contributors!
16 ########################################################################
16 ########################################################################
17
17
18 # Are we running as root?
18 # Are we running as root?
19 if [ "$(id -u)" -ne "0" ] ; then
19 if [ "$(id -u)" -ne "0" ] ; then
20 echo "error: this script must be executed with root privileges!"
20 echo "error: this script must be executed with root privileges!"
21 exit 1
21 exit 1
22 fi
22 fi
23
23
24 # Check if ./functions.sh script exists
24 # Check if ./functions.sh script exists
25 if [ ! -r "./functions.sh" ] ; then
25 if [ ! -r "./functions.sh" ] ; then
26 echo "error: './functions.sh' required script not found!"
26 echo "error: './functions.sh' required script not found!"
27 exit 1
27 exit 1
28 fi
28 fi
29
29
30 # Load utility functions
30 # Load utility functions
31 . ./functions.sh
31 . ./functions.sh
32
32
33 # Load parameters from configuration template file
33 # Load parameters from configuration template file
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 use_template
35 use_template
36 fi
36 fi
37
37
38 # Introduce settings
38 # Introduce settings
39 set -e
39 set -e
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 set -x
41 set -x
42
42
43 # Raspberry Pi model configuration
43 # Raspberry Pi model configuration
44 RPI_MODEL=${RPI_MODEL:=2}
44 RPI_MODEL=${RPI_MODEL:=2}
45
45
46 # Debian release
46 # Debian release
47 RELEASE=${RELEASE:=jessie}
47 RELEASE=${RELEASE:=jessie}
48
48
49 #Kernel Branch
49 #Kernel Branch
50 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
51
51
52 # URLs
52 # URLs
53 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
54 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
55 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
56 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
57 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
58 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
59
59
60 # Build directories
60 # Build directories
61 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
61 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
62 BUILDDIR="${BASEDIR}/build"
62 BUILDDIR="${BASEDIR}/build"
63
63
64 # Prepare date string for default image file name
64 # Prepare date string for default image file name
65 DATE="$(date +%Y-%m-%d)"
65 DATE="$(date +%Y-%m-%d)"
66 if [ -z "$KERNEL_BRANCH" ] ; then
66 if [ -z "$KERNEL_BRANCH" ] ; then
67 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
67 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
68 else
68 else
69 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
69 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
70 fi
70 fi
71
71
72 # Chroot directories
72 # Chroot directories
73 R="${BUILDDIR}/chroot"
73 R="${BUILDDIR}/chroot"
74 ETC_DIR="${R}/etc"
74 ETC_DIR="${R}/etc"
75 LIB_DIR="${R}/lib"
75 LIB_DIR="${R}/lib"
76 BOOT_DIR="${R}/boot/firmware"
76 BOOT_DIR="${R}/boot/firmware"
77 KERNEL_DIR="${R}/usr/src/linux"
77 KERNEL_DIR="${R}/usr/src/linux"
78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
79
79
80 # Firmware directory: Blank if download from github
80 # Firmware directory: Blank if download from github
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
82
82
83 # General settings
83 # General settings
84 SET_ARCH=${SET_ARCH}
84 SET_ARCH=${SET_ARCH}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
86 PASSWORD=${PASSWORD:=raspberry}
86 PASSWORD=${PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
90 EXPANDROOT=${EXPANDROOT:=true}
90 EXPANDROOT=${EXPANDROOT:=true}
91
91
92 # Keyboard settings
92 # Keyboard settings
93 XKB_MODEL=${XKB_MODEL:=""}
93 XKB_MODEL=${XKB_MODEL:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
97
97
98 # Network settings (DHCP)
98 # Network settings (DHCP)
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
100
100
101 # Network settings (static)
101 # Network settings (static)
102 NET_ADDRESS=${NET_ADDRESS:=""}
102 NET_ADDRESS=${NET_ADDRESS:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
109
109
110 # APT settings
110 # APT settings
111 APT_PROXY=${APT_PROXY:=""}
111 APT_PROXY=${APT_PROXY:=""}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
113
113
114 # Feature settings
114 # Feature settings
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
116 ENABLE_I2C=${ENABLE_I2C:=false}
116 ENABLE_I2C=${ENABLE_I2C:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
127 ENABLE_WM=${ENABLE_WM:=""}
127 ENABLE_WM=${ENABLE_WM:=""}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
130 USER_NAME=${USER_NAME:="pi"}
130 USER_NAME=${USER_NAME:="pi"}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
133
133
134 # SSH settings
134 # SSH settings
135 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
135 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
136 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
136 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
137 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
137 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
138 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
138 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
139 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
139 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
140
140
141 # Advanced settings
141 # Advanced settings
142 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
142 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
143 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
143 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
144 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
144 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
145 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
145 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
146 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
146 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
147 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
147 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
148 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
148 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
149 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
149 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
150 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
150 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
151 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
151 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
152 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
152 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
153 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
153 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
154
154
155 # Kernel compilation settings
155 # Kernel compilation settings
156 BUILD_KERNEL=${BUILD_KERNEL:=false}
156 BUILD_KERNEL=${BUILD_KERNEL:=false}
157 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
157 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
158 KERNEL_THREADS=${KERNEL_THREADS:=1}
158 KERNEL_THREADS=${KERNEL_THREADS:=1}
159 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
159 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
160 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
160 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
161 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
161 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
162 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
162 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
163 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
163 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
164
164
165 # Kernel compilation from source directory settings
165 # Kernel compilation from source directory settings
166 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
166 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
167 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
167 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
168 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
168 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
169 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
169 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
170
170
171 # Reduce disk usage settings
171 # Reduce disk usage settings
172 REDUCE_APT=${REDUCE_APT:=true}
172 REDUCE_APT=${REDUCE_APT:=true}
173 REDUCE_DOC=${REDUCE_DOC:=true}
173 REDUCE_DOC=${REDUCE_DOC:=true}
174 REDUCE_MAN=${REDUCE_MAN:=true}
174 REDUCE_MAN=${REDUCE_MAN:=true}
175 REDUCE_VIM=${REDUCE_VIM:=false}
175 REDUCE_VIM=${REDUCE_VIM:=false}
176 REDUCE_BASH=${REDUCE_BASH:=false}
176 REDUCE_BASH=${REDUCE_BASH:=false}
177 REDUCE_HWDB=${REDUCE_HWDB:=true}
177 REDUCE_HWDB=${REDUCE_HWDB:=true}
178 REDUCE_SSHD=${REDUCE_SSHD:=true}
178 REDUCE_SSHD=${REDUCE_SSHD:=true}
179 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
179 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
180
180
181 # Encrypted filesystem settings
181 # Encrypted filesystem settings
182 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
182 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
183 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
183 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
184 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
184 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
185 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
185 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
186 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
186 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
187
187
188 # Chroot scripts directory
188 # Chroot scripts directory
189 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
189 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
190
190
191 # Packages required in the chroot build environment
191 # Packages required in the chroot build environment
192 APT_INCLUDES=${APT_INCLUDES:=""}
192 APT_INCLUDES=${APT_INCLUDES:=""}
193 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
193 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
194
194
195 # Packages required for bootstrapping
195 # Packages required for bootstrapping
196 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
196 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
197 MISSING_PACKAGES=""
197 MISSING_PACKAGES=""
198
198
199 # Packages installed for c/c++ build environment in chroot (keep empty)
199 # Packages installed for c/c++ build environment in chroot (keep empty)
200 COMPILER_PACKAGES=""
200 COMPILER_PACKAGES=""
201
201
202 set +x
202 set +x
203
203
204 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
204 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
205 if [ -n "$SET_ARCH" ]
205 if [ -n "$SET_ARCH" ]
206 echo "Setting Architecture specific settings"
206 echo "Setting Architecture specific settings"
207 ##################################
207 ##################################
208 # 64 bit config
208 # 64 bit config
209 ##################################
209 ##################################
210 if [ "$SET_ARCH" = 64 ] && ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]); then
210 if [ "$SET_ARCH" = 64 ] && ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]); then
211 echo "64 bit mode selected - Setting up enviroment"
211 echo "64 bit mode selected - Setting up enviroment"
212 # 64 bit depended settings
212 # 64 bit depended settings
213 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
213 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
214 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
214 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
215 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
215 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
216 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
216 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
217 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
217 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
218 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
218 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
219
219
220 # RPI 3 serie specific settings
220 # RPI 3 serie specific settings
221 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
221 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
222 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
222 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
223
223
224 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
224 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
225 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
225 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
226 else
226 else
227 echo "error: Only Raspberry PI 3 and 3B+ support 64bit"
227 echo "error: Only Raspberry PI 3 and 3B+ support 64bit"
228 exit 1
228 exit 1
229 fi
229 fi
230
230
231 ##################################
231 ##################################
232 # 32 bit config
232 # 32 bit config
233 ##################################
233 ##################################
234 if [ "$SET_ARCH" = 32 ] ; then
234 if [ "$SET_ARCH" = 32 ] ; then
235 echo "32 bit mode selected - Setting up enviroment"
235 echo "32 bit mode selected - Setting up enviroment"
236 #General 32bit configuration
236 #General 32bit configuration
237 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
237 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
238 KERNEL_ARCH=${KERNEL_ARCH:=arm}
238 KERNEL_ARCH=${KERNEL_ARCH:=arm}
239 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
239 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
240
240
241 #Raspberry setting grouped by board compability
241 #Raspberry setting grouped by board compability
242 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
242 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
243 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
243 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
244 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
244 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
245 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
245 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
246 RELEASE_ARCH=${RELEASE_ARCH:=armel}
246 RELEASE_ARCH=${RELEASE_ARCH:=armel}
247 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
247 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
248 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
248 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
249 elif [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
249 elif [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
250 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
250 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
251 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
251 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
252 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
252 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
253 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
253 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
254 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
254 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
255 fi
255 fi
256
256
257 #Device specific configuration
257 #Device specific configuration
258 case "$RPI_MODEL" in
258 case "$RPI_MODEL" in
259 0)
259 0)
260 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb} ;;
260 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb} ;;
261 1)
261 1)
262 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb} ;;
262 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb} ;;
263 1P)
263 1P)
264 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb} ;;
264 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb} ;;
265 2)
265 2)
266 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
266 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
267 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
267 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
268 #Precompiled Kernel rpi2
268 #Precompiled Kernel rpi2
269 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
269 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
270 ;;
270 ;;
271 3)
271 3)
272 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
272 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
273 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
273 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
274 ;;
274 ;;
275 3P
275 3P
276 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
276 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
277 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
277 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
278 ;;
278 ;;
279 *)
279 *)
280 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
280 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
281 exit 1
281 exit 1
282 ;;
282 ;;
283 esac
283 esac
284 fi
284 fi
285 else
285 else
286 echo "error: Please set '32' or '64' as value for SET_ARCH"
286 echo "error: Please set '32' or '64' as value for SET_ARCH"
287 exit 1
287 exit 1
288 fi
288 fi
289
289
290 # Check if the internal wireless interface is supported by the RPi model
290 # Check if the internal wireless interface is supported by the RPi model
291 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]) ; then
291 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]) ; then
292 echo "error: The selected Raspberry Pi model has no internal wireless interface"
292 echo "error: The selected Raspberry Pi model has no internal wireless interface"
293 exit 1
293 exit 1
294 else
294 else
295 echo "Raspberry Pi model"
295 echo "Raspberry Pi model"
296 fi
296 fi
297
297
298 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
298 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
299 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
299 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
300 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
300 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
301 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
301 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
302 exit 1
302 exit 1
303 fi
303 fi
304 fi
304 fi
305
305
306 # Add libncurses5 to enable kernel menuconfig
306 # Add libncurses5 to enable kernel menuconfig
307 if [ "$KERNEL_MENUCONFIG" = true ] ; then
307 if [ "$KERNEL_MENUCONFIG" = true ] ; then
308 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
308 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
309 fi
309 fi
310
310
311 # Add ccache compiler cache for (faster) kernel cross (re)compilation
311 # Add ccache compiler cache for (faster) kernel cross (re)compilation
312 if [ "$KERNEL_CCACHE" = true ] ; then
312 if [ "$KERNEL_CCACHE" = true ] ; then
313 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
313 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
314 fi
314 fi
315
315
316 # Add cryptsetup package to enable filesystem encryption
316 # Add cryptsetup package to enable filesystem encryption
317 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
317 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
318 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
318 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
319 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
319 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
320
320
321 if [ -z "$CRYPTFS_PASSWORD" ] ; then
321 if [ -z "$CRYPTFS_PASSWORD" ] ; then
322 echo "error: no password defined (CRYPTFS_PASSWORD)!"
322 echo "error: no password defined (CRYPTFS_PASSWORD)!"
323 exit 1
323 exit 1
324 fi
324 fi
325 ENABLE_INITRAMFS=true
325 ENABLE_INITRAMFS=true
326 fi
326 fi
327
327
328 # Add initramfs generation tools
328 # Add initramfs generation tools
329 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
329 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
330 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
330 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
331 fi
331 fi
332
332
333 # Add device-tree-compiler required for building the U-Boot bootloader
333 # Add device-tree-compiler required for building the U-Boot bootloader
334 if [ "$ENABLE_UBOOT" = true ] ; then
334 if [ "$ENABLE_UBOOT" = true ] ; then
335 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
335 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
336 fi
336 fi
337
337
338 # Check if root SSH (v2) public key file exists
338 # Check if root SSH (v2) public key file exists
339 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
339 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
340 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
340 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
341 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
341 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
342 exit 1
342 exit 1
343 fi
343 fi
344 fi
344 fi
345
345
346 # Check if $USER_NAME SSH (v2) public key file exists
346 # Check if $USER_NAME SSH (v2) public key file exists
347 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
347 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
348 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
348 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
349 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
349 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
350 exit 1
350 exit 1
351 fi
351 fi
352 fi
352 fi
353
353
354 # Check if all required packages are installed on the build system
354 # Check if all required packages are installed on the build system
355 for package in $REQUIRED_PACKAGES ; do
355 for package in $REQUIRED_PACKAGES ; do
356 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
356 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
357 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
357 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
358 fi
358 fi
359 done
359 done
360
360
361 # If there are missing packages ask confirmation for install, or exit
361 # If there are missing packages ask confirmation for install, or exit
362 if [ -n "$MISSING_PACKAGES" ] ; then
362 if [ -n "$MISSING_PACKAGES" ] ; then
363 echo "the following packages needed by this script are not installed:"
363 echo "the following packages needed by this script are not installed:"
364 echo "$MISSING_PACKAGES"
364 echo "$MISSING_PACKAGES"
365
365
366 echo -n "\ndo you want to install the missing packages right now? [y/n] "
366 echo -n "\ndo you want to install the missing packages right now? [y/n] "
367 read confirm
367 read confirm
368 [ "$confirm" != "y" ] && exit 1
368 [ "$confirm" != "y" ] && exit 1
369
369
370 # Make sure all missing required packages are installed
370 # Make sure all missing required packages are installed
371 apt-get -qq -y install ${MISSING_PACKAGES}
371 apt-get -qq -y install ${MISSING_PACKAGES}
372 fi
372 fi
373
373
374 # Check if ./bootstrap.d directory exists
374 # Check if ./bootstrap.d directory exists
375 if [ ! -d "./bootstrap.d/" ] ; then
375 if [ ! -d "./bootstrap.d/" ] ; then
376 echo "error: './bootstrap.d' required directory not found!"
376 echo "error: './bootstrap.d' required directory not found!"
377 exit 1
377 exit 1
378 fi
378 fi
379
379
380 # Check if ./files directory exists
380 # Check if ./files directory exists
381 if [ ! -d "./files/" ] ; then
381 if [ ! -d "./files/" ] ; then
382 echo "error: './files' required directory not found!"
382 echo "error: './files' required directory not found!"
383 exit 1
383 exit 1
384 fi
384 fi
385
385
386 # Check if specified KERNELSRC_DIR directory exists
386 # Check if specified KERNELSRC_DIR directory exists
387 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
387 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
388 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
388 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
389 exit 1
389 exit 1
390 fi
390 fi
391
391
392 # Check if specified UBOOTSRC_DIR directory exists
392 # Check if specified UBOOTSRC_DIR directory exists
393 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
393 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
394 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
394 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
395 exit 1
395 exit 1
396 fi
396 fi
397
397
398 # Check if specified FBTURBOSRC_DIR directory exists
398 # Check if specified FBTURBOSRC_DIR directory exists
399 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
399 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
400 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
400 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
401 exit 1
401 exit 1
402 fi
402 fi
403
403
404 # Check if specified CHROOT_SCRIPTS directory exists
404 # Check if specified CHROOT_SCRIPTS directory exists
405 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
405 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
406 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
406 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
407 exit 1
407 exit 1
408 fi
408 fi
409
409
410 # Check if specified device mapping already exists (will be used by cryptsetup)
410 # Check if specified device mapping already exists (will be used by cryptsetup)
411 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
411 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
412 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
412 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
413 exit 1
413 exit 1
414 fi
414 fi
415
415
416 # Don't clobber an old build
416 # Don't clobber an old build
417 if [ -e "$BUILDDIR" ] ; then
417 if [ -e "$BUILDDIR" ] ; then
418 echo "error: directory ${BUILDDIR} already exists, not proceeding"
418 echo "error: directory ${BUILDDIR} already exists, not proceeding"
419 exit 1
419 exit 1
420 fi
420 fi
421
421
422 # Setup chroot directory
422 # Setup chroot directory
423 mkdir -p "${R}"
423 mkdir -p "${R}"
424
424
425 # Check if build directory has enough of free disk space >512MB
425 # Check if build directory has enough of free disk space >512MB
426 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
426 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
427 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
427 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
428 exit 1
428 exit 1
429 fi
429 fi
430
430
431 set -x
431 set -x
432
432
433 # Call "cleanup" function on various signals and errors
433 # Call "cleanup" function on various signals and errors
434 trap cleanup 0 1 2 3 6
434 trap cleanup 0 1 2 3 6
435
435
436 # Add required packages for the minbase installation
436 # Add required packages for the minbase installation
437 if [ "$ENABLE_MINBASE" = true ] ; then
437 if [ "$ENABLE_MINBASE" = true ] ; then
438 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
438 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
439 fi
439 fi
440
440
441 # Add required locales packages
441 # Add required locales packages
442 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
442 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
443 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
443 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
444 fi
444 fi
445
445
446 # Add parted package, required to get partprobe utility
446 # Add parted package, required to get partprobe utility
447 if [ "$EXPANDROOT" = true ] ; then
447 if [ "$EXPANDROOT" = true ] ; then
448 APT_INCLUDES="${APT_INCLUDES},parted"
448 APT_INCLUDES="${APT_INCLUDES},parted"
449 fi
449 fi
450
450
451 # Add dbus package, recommended if using systemd
451 # Add dbus package, recommended if using systemd
452 if [ "$ENABLE_DBUS" = true ] ; then
452 if [ "$ENABLE_DBUS" = true ] ; then
453 APT_INCLUDES="${APT_INCLUDES},dbus"
453 APT_INCLUDES="${APT_INCLUDES},dbus"
454 fi
454 fi
455
455
456 # Add iptables IPv4/IPv6 package
456 # Add iptables IPv4/IPv6 package
457 if [ "$ENABLE_IPTABLES" = true ] ; then
457 if [ "$ENABLE_IPTABLES" = true ] ; then
458 APT_INCLUDES="${APT_INCLUDES},iptables"
458 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
459 fi
459 fi
460
460
461 # Add openssh server package
461 # Add openssh server package
462 if [ "$ENABLE_SSHD" = true ] ; then
462 if [ "$ENABLE_SSHD" = true ] ; then
463 APT_INCLUDES="${APT_INCLUDES},openssh-server"
463 APT_INCLUDES="${APT_INCLUDES},openssh-server"
464 fi
464 fi
465
465
466 # Add alsa-utils package
466 # Add alsa-utils package
467 if [ "$ENABLE_SOUND" = true ] ; then
467 if [ "$ENABLE_SOUND" = true ] ; then
468 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
468 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
469 fi
469 fi
470
470
471 # Add rng-tools package
471 # Add rng-tools package
472 if [ "$ENABLE_HWRANDOM" = true ] ; then
472 if [ "$ENABLE_HWRANDOM" = true ] ; then
473 APT_INCLUDES="${APT_INCLUDES},rng-tools"
473 APT_INCLUDES="${APT_INCLUDES},rng-tools"
474 fi
474 fi
475
475
476 # Add fbturbo video driver
476 # Add fbturbo video driver
477 if [ "$ENABLE_FBTURBO" = true ] ; then
477 if [ "$ENABLE_FBTURBO" = true ] ; then
478 # Enable xorg package dependencies
478 # Enable xorg package dependencies
479 ENABLE_XORG=true
479 ENABLE_XORG=true
480 fi
480 fi
481
481
482 # Add user defined window manager package
482 # Add user defined window manager package
483 if [ -n "$ENABLE_WM" ] ; then
483 if [ -n "$ENABLE_WM" ] ; then
484 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
484 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
485
485
486 # Enable xorg package dependencies
486 # Enable xorg package dependencies
487 ENABLE_XORG=true
487 ENABLE_XORG=true
488 fi
488 fi
489
489
490 # Add xorg package
490 # Add xorg package
491 if [ "$ENABLE_XORG" = true ] ; then
491 if [ "$ENABLE_XORG" = true ] ; then
492 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
492 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
493 fi
493 fi
494
494
495 # Replace selected packages with smaller clones
495 # Replace selected packages with smaller clones
496 if [ "$ENABLE_REDUCE" = true ] ; then
496 if [ "$ENABLE_REDUCE" = true ] ; then
497 # Add levee package instead of vim-tiny
497 # Add levee package instead of vim-tiny
498 if [ "$REDUCE_VIM" = true ] ; then
498 if [ "$REDUCE_VIM" = true ] ; then
499 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
499 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
500 fi
500 fi
501
501
502 # Add dropbear package instead of openssh-server
502 # Add dropbear package instead of openssh-server
503 if [ "$REDUCE_SSHD" = true ] ; then
503 if [ "$REDUCE_SSHD" = true ] ; then
504 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
504 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
505 fi
505 fi
506 fi
506 fi
507
507
508 if [ "$RELEASE" != "jessie" ] ; then
508 if [ "$RELEASE" != "jessie" ] ; then
509 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
509 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
510 fi
510 fi
511
511
512 # Configure kernel sources if no KERNELSRC_DIR
512 # Configure kernel sources if no KERNELSRC_DIR
513 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
513 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
514 KERNELSRC_CONFIG=true
514 KERNELSRC_CONFIG=true
515 fi
515 fi
516
516
517 # Configure reduced kernel
517 # Configure reduced kernel
518 if [ "$KERNEL_REDUCE" = true ] ; then
518 if [ "$KERNEL_REDUCE" = true ] ; then
519 KERNELSRC_CONFIG=false
519 KERNELSRC_CONFIG=false
520 fi
520 fi
521
521
522 # Execute bootstrap scripts
522 # Execute bootstrap scripts
523 for SCRIPT in bootstrap.d/*.sh; do
523 for SCRIPT in bootstrap.d/*.sh; do
524 head -n 3 "$SCRIPT"
524 head -n 3 "$SCRIPT"
525 . "$SCRIPT"
525 . "$SCRIPT"
526 done
526 done
527
527
528 ## Execute custom bootstrap scripts
528 ## Execute custom bootstrap scripts
529 if [ -d "custom.d" ] ; then
529 if [ -d "custom.d" ] ; then
530 for SCRIPT in custom.d/*.sh; do
530 for SCRIPT in custom.d/*.sh; do
531 . "$SCRIPT"
531 . "$SCRIPT"
532 done
532 done
533 fi
533 fi
534
534
535 # Execute custom scripts inside the chroot
535 # Execute custom scripts inside the chroot
536 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
536 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
537 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
537 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
538 chroot_exec /bin/bash -x <<'EOF'
538 chroot_exec /bin/bash -x <<'EOF'
539 for SCRIPT in /chroot_scripts/* ; do
539 for SCRIPT in /chroot_scripts/* ; do
540 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
540 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
541 $SCRIPT
541 $SCRIPT
542 fi
542 fi
543 done
543 done
544 EOF
544 EOF
545 rm -rf "${R}/chroot_scripts"
545 rm -rf "${R}/chroot_scripts"
546 fi
546 fi
547
547
548 # Remove c/c++ build environment from the chroot
548 # Remove c/c++ build environment from the chroot
549 chroot_remove_cc
549 chroot_remove_cc
550
550
551 # Remove apt-utils
551 # Remove apt-utils
552 if [ "$RELEASE" = "jessie" ] ; then
552 if [ "$RELEASE" = "jessie" ] ; then
553 chroot_exec apt-get purge -qq -y --force-yes apt-utils
553 chroot_exec apt-get purge -qq -y --force-yes apt-utils
554 fi
554 fi
555
555
556 # Generate required machine-id
556 # Generate required machine-id
557 MACHINE_ID=$(dbus-uuidgen)
557 MACHINE_ID=$(dbus-uuidgen)
558 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
558 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
559 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
559 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
560
560
561 # APT Cleanup
561 # APT Cleanup
562 chroot_exec apt-get -y clean
562 chroot_exec apt-get -y clean
563 chroot_exec apt-get -y autoclean
563 chroot_exec apt-get -y autoclean
564 chroot_exec apt-get -y autoremove
564 chroot_exec apt-get -y autoremove
565
565
566 # Unmount mounted filesystems
566 # Unmount mounted filesystems
567 umount -l "${R}/proc"
567 umount -l "${R}/proc"
568 umount -l "${R}/sys"
568 umount -l "${R}/sys"
569
569
570 # Clean up directories
570 # Clean up directories
571 rm -rf "${R}/run/*"
571 rm -rf "${R}/run/*"
572 rm -rf "${R}/tmp/*"
572 rm -rf "${R}/tmp/*"
573
573
574 # Clean up files
574 # Clean up files
575 rm -f "${ETC_DIR}/ssh/ssh_host_*"
575 rm -f "${ETC_DIR}/ssh/ssh_host_*"
576 rm -f "${ETC_DIR}/dropbear/dropbear_*"
576 rm -f "${ETC_DIR}/dropbear/dropbear_*"
577 rm -f "${ETC_DIR}/apt/sources.list.save"
577 rm -f "${ETC_DIR}/apt/sources.list.save"
578 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
578 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
579 rm -f "${ETC_DIR}/*-"
579 rm -f "${ETC_DIR}/*-"
580 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
580 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
581 rm -f "${ETC_DIR}/resolv.conf"
581 rm -f "${ETC_DIR}/resolv.conf"
582 rm -f "${R}/root/.bash_history"
582 rm -f "${R}/root/.bash_history"
583 rm -f "${R}/var/lib/urandom/random-seed"
583 rm -f "${R}/var/lib/urandom/random-seed"
584 rm -f "${R}/initrd.img"
584 rm -f "${R}/initrd.img"
585 rm -f "${R}/vmlinuz"
585 rm -f "${R}/vmlinuz"
586 rm -f "${R}${QEMU_BINARY}"
586 rm -f "${R}${QEMU_BINARY}"
587
587
588 if [ "$ENABLE_QEMU" = true ] ; then
588 if [ "$ENABLE_QEMU" = true ] ; then
589 # Configure qemu compatible kernel
589 # Configure qemu compatible kernel
590 DTB_FILE=vexpress-v2p-ca15_a7.dtb
590 DTB_FILE=vexpress-v2p-ca15_a7.dtb
591 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
591 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
592 KERNEL_DEFCONFIG="vexpress_defconfig"
592 KERNEL_DEFCONFIG="vexpress_defconfig"
593 if [ "$KERNEL_MENUCONFIG" = false ] ; then
593 if [ "$KERNEL_MENUCONFIG" = false ] ; then
594 KERNEL_OLDDEFCONFIG=true
594 KERNEL_OLDDEFCONFIG=true
595 fi
595 fi
596
596
597 # Setup QEMU directory
597 # Setup QEMU directory
598 mkdir "${BASEDIR}/qemu"
598 mkdir "${BASEDIR}/qemu"
599
599
600 # Copy kernel image to QEMU directory
600 # Copy kernel image to QEMU directory
601 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
601 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
602
602
603 # Copy kernel config to QEMU directory
603 # Copy kernel config to QEMU directory
604 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
604 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
605
605
606 # Copy kernel dtbs to QEMU directory
606 # Copy kernel dtbs to QEMU directory
607 for dtb in "${BOOT_DIR}/"*.dtb ; do
607 for dtb in "${BOOT_DIR}/"*.dtb ; do
608 if [ -f "${dtb}" ] ; then
608 if [ -f "${dtb}" ] ; then
609 install_readonly "${dtb}" "${BASEDIR}/qemu/"
609 install_readonly "${dtb}" "${BASEDIR}/qemu/"
610 fi
610 fi
611 done
611 done
612
612
613 # Copy kernel overlays to QEMU directory
613 # Copy kernel overlays to QEMU directory
614 if [ -d "${BOOT_DIR}/overlays" ] ; then
614 if [ -d "${BOOT_DIR}/overlays" ] ; then
615 # Setup overlays dtbs directory
615 # Setup overlays dtbs directory
616 mkdir "${BASEDIR}/qemu/overlays"
616 mkdir "${BASEDIR}/qemu/overlays"
617
617
618 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
618 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
619 if [ -f "${dtb}" ] ; then
619 if [ -f "${dtb}" ] ; then
620 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
620 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
621 fi
621 fi
622 done
622 done
623 fi
623 fi
624
624
625 # Copy u-boot files to QEMU directory
625 # Copy u-boot files to QEMU directory
626 if [ "$ENABLE_UBOOT" = true ] ; then
626 if [ "$ENABLE_UBOOT" = true ] ; then
627 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
627 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
628 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
628 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
629 fi
629 fi
630 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
630 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
631 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
631 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
632 fi
632 fi
633 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
633 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
634 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
634 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
635 fi
635 fi
636 fi
636 fi
637
637
638 # Copy initramfs to QEMU directory
638 # Copy initramfs to QEMU directory
639 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
639 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
640 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
640 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
641 fi
641 fi
642 fi
642 fi
643
643
644 # Calculate size of the chroot directory in KB
644 # Calculate size of the chroot directory in KB
645 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
645 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
646
646
647 # Calculate the amount of needed 512 Byte sectors
647 # Calculate the amount of needed 512 Byte sectors
648 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
648 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
649 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
649 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
650 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
650 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
651
651
652 # The root partition is EXT4
652 # The root partition is EXT4
653 # This means more space than the actual used space of the chroot is used.
653 # This means more space than the actual used space of the chroot is used.
654 # As overhead for journaling and reserved blocks 35% are added.
654 # As overhead for journaling and reserved blocks 35% are added.
655 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
655 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
656
656
657 # Calculate required image size in 512 Byte sectors
657 # Calculate required image size in 512 Byte sectors
658 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
658 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
659
659
660 # Prepare image file
660 # Prepare image file
661 if [ "$ENABLE_SPLITFS" = true ] ; then
661 if [ "$ENABLE_SPLITFS" = true ] ; then
662 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
662 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
663 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
663 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
664 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
664 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
665 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
665 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
666
666
667 # Write firmware/boot partition tables
667 # Write firmware/boot partition tables
668 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
668 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
669 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
669 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
670 EOM
670 EOM
671
671
672 # Write root partition table
672 # Write root partition table
673 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
673 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
674 ${TABLE_SECTORS},${ROOT_SECTORS},83
674 ${TABLE_SECTORS},${ROOT_SECTORS},83
675 EOM
675 EOM
676
676
677 # Setup temporary loop devices
677 # Setup temporary loop devices
678 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
678 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
679 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
679 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
680 else # ENABLE_SPLITFS=false
680 else # ENABLE_SPLITFS=false
681 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
681 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
682 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
682 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
683
683
684 # Write partition table
684 # Write partition table
685 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
685 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
686 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
686 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
687 ${ROOT_OFFSET},${ROOT_SECTORS},83
687 ${ROOT_OFFSET},${ROOT_SECTORS},83
688 EOM
688 EOM
689
689
690 # Setup temporary loop devices
690 # Setup temporary loop devices
691 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
691 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
692 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
692 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
693 fi
693 fi
694
694
695 if [ "$ENABLE_CRYPTFS" = true ] ; then
695 if [ "$ENABLE_CRYPTFS" = true ] ; then
696 # Create dummy ext4 fs
696 # Create dummy ext4 fs
697 mkfs.ext4 "$ROOT_LOOP"
697 mkfs.ext4 "$ROOT_LOOP"
698
698
699 # Setup password keyfile
699 # Setup password keyfile
700 touch .password
700 touch .password
701 chmod 600 .password
701 chmod 600 .password
702 echo -n ${CRYPTFS_PASSWORD} > .password
702 echo -n ${CRYPTFS_PASSWORD} > .password
703
703
704 # Initialize encrypted partition
704 # Initialize encrypted partition
705 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
705 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
706
706
707 # Open encrypted partition and setup mapping
707 # Open encrypted partition and setup mapping
708 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
708 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
709
709
710 # Secure delete password keyfile
710 # Secure delete password keyfile
711 shred -zu .password
711 shred -zu .password
712
712
713 # Update temporary loop device
713 # Update temporary loop device
714 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
714 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
715
715
716 # Wipe encrypted partition (encryption cipher is used for randomness)
716 # Wipe encrypted partition (encryption cipher is used for randomness)
717 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
717 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
718 fi
718 fi
719
719
720 # Build filesystems
720 # Build filesystems
721 mkfs.vfat "$FRMW_LOOP"
721 mkfs.vfat "$FRMW_LOOP"
722 mkfs.ext4 "$ROOT_LOOP"
722 mkfs.ext4 "$ROOT_LOOP"
723
723
724 # Mount the temporary loop devices
724 # Mount the temporary loop devices
725 mkdir -p "$BUILDDIR/mount"
725 mkdir -p "$BUILDDIR/mount"
726 mount "$ROOT_LOOP" "$BUILDDIR/mount"
726 mount "$ROOT_LOOP" "$BUILDDIR/mount"
727
727
728 mkdir -p "$BUILDDIR/mount/boot/firmware"
728 mkdir -p "$BUILDDIR/mount/boot/firmware"
729 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
729 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
730
730
731 # Copy all files from the chroot to the loop device mount point directory
731 # Copy all files from the chroot to the loop device mount point directory
732 rsync -a "${R}/" "$BUILDDIR/mount/"
732 rsync -a "${R}/" "$BUILDDIR/mount/"
733
733
734 # Unmount all temporary loop devices and mount points
734 # Unmount all temporary loop devices and mount points
735 cleanup
735 cleanup
736
736
737 # Create block map file(s) of image(s)
737 # Create block map file(s) of image(s)
738 if [ "$ENABLE_SPLITFS" = true ] ; then
738 if [ "$ENABLE_SPLITFS" = true ] ; then
739 # Create block map files for "bmaptool"
739 # Create block map files for "bmaptool"
740 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
740 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
741 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
741 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
742
742
743 # Image was successfully created
743 # Image was successfully created
744 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
744 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
745 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
745 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
746 else
746 else
747 # Create block map file for "bmaptool"
747 # Create block map file for "bmaptool"
748 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
748 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
749
749
750 # Image was successfully created
750 # Image was successfully created
751 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
751 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
752
752
753 # Create qemu qcow2 image
753 # Create qemu qcow2 image
754 if [ "$ENABLE_QEMU" = true ] ; then
754 if [ "$ENABLE_QEMU" = true ] ; then
755 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
755 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
756 QEMU_SIZE=16G
756 QEMU_SIZE=16G
757
757
758 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
758 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
759 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
759 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
760
760
761 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
761 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
762 fi
762 fi
763 fi
763 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant